From 2c5aa9bfc2f5b027cef7c3614b07e0b3da4ec7ba Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Tue, 4 Feb 2020 18:10:01 -0500
Subject: [PATCH 2/9] FIXME: new implementation of state

---
 cover-letter.txt                              |  133 +
 gcc/Makefile.in                               |    8 +-
 gcc/analyzer/analyzer-logging.cc              |    2 +
 gcc/analyzer/analyzer-selftests.cc            |    1 +
 gcc/analyzer/analyzer-selftests.h             |    1 +
 gcc/analyzer/analyzer.cc                      |   30 +
 gcc/analyzer/analyzer.h                       |  192 +-
 gcc/analyzer/analyzer.opt                     |    8 +
 gcc/analyzer/call-string.cc                   |    2 +
 gcc/analyzer/checker-path.cc                  |   52 +-
 gcc/analyzer/checker-path.h                   |   12 +-
 gcc/analyzer/constraint-manager.cc            | 1226 ++-
 gcc/analyzer/constraint-manager.h             |  113 +-
 gcc/analyzer/diagnostic-manager.cc            |  451 +-
 gcc/analyzer/diagnostic-manager.h             |   20 +-
 gcc/analyzer/engine.cc                        |  800 +-
 gcc/analyzer/exploded-graph.h                 |   65 +-
 gcc/analyzer/program-point.cc                 |   61 +
 gcc/analyzer/program-point.h                  |   52 +-
 gcc/analyzer/program-state.cc                 | 1271 +--
 gcc/analyzer/program-state.h                  |  240 +-
 gcc/analyzer/region-model-impl-calls.cc       |  352 +
 gcc/analyzer/region-model-manager.cc          | 1089 ++
 gcc/analyzer/region-model-reachability.cc     |  280 +
 gcc/analyzer/region-model-reachability.h      |  117 +
 gcc/analyzer/region-model.cc                  | 9005 +++++------------
 gcc/analyzer/region-model.h                   | 3137 +++---
 gcc/analyzer/region.cc                        | 1064 ++
 gcc/analyzer/sm-file.cc                       |   26 +-
 gcc/analyzer/sm-malloc.cc                     |  164 +-
 gcc/analyzer/sm-sensitive.cc                  |    3 +-
 gcc/analyzer/sm-signal.cc                     |   15 +-
 gcc/analyzer/sm-taint.cc                      |    9 +-
 gcc/analyzer/sm.cc                            |   21 +-
 gcc/analyzer/sm.h                             |   35 +-
 gcc/analyzer/store.cc                         | 2008 ++++
 gcc/analyzer/store.h                          |  613 ++
 gcc/analyzer/svalue.cc                        | 1004 ++
 gcc/doc/analyzer.texi                         |  110 +-
 gcc/testsuite/g++.dg/analyzer/pr93212.C       |    5 +-
 gcc/testsuite/g++.dg/analyzer/pr93950.C       |    4 +-
 gcc/testsuite/g++.dg/analyzer/pr94011.C       |   16 +
 gcc/testsuite/g++.dg/analyzer/pr94028.C       |    4 +-
 gcc/testsuite/g++.dg/analyzer/pr94503.C       |   25 +
 gcc/testsuite/g++.dg/analyzer/pr95042.C       |   28 +
 .../analyzer/CVE-2005-1689-dedupe-issue-2.c   |   30 +
 .../analyzer/CVE-2005-1689-dedupe-issue.c     |    2 +-
 .../gcc.dg/analyzer/CVE-2005-1689-minimal.c   |   61 +
 gcc/testsuite/gcc.dg/analyzer/abs-1.c         |   22 +
 gcc/testsuite/gcc.dg/analyzer/aliasing-1.c    |   25 +
 gcc/testsuite/gcc.dg/analyzer/aliasing-2.c    |   32 +
 .../gcc.dg/analyzer/analyzer-decls.h          |    7 +-
 .../gcc.dg/analyzer/attribute-nonnull.c       |   12 +-
 gcc/testsuite/gcc.dg/analyzer/bzero-1.c       |   11 +
 gcc/testsuite/gcc.dg/analyzer/casts-1.c       |   49 +
 gcc/testsuite/gcc.dg/analyzer/casts-2.c       |   15 +
 .../gcc.dg/analyzer/compound-assignment-1.c   |    9 +-
 .../gcc.dg/analyzer/compound-assignment-3.c   |    2 +-
 .../gcc.dg/analyzer/compound-assignment-4.c   |   28 +
 .../gcc.dg/analyzer/compound-assignment-5.c   |  142 +
 .../gcc.dg/analyzer/conditionals-notrans.c    |   33 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-1.c  |   96 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-13.c |    7 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-14.c |    9 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-18.c |    4 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-20.c |   25 +
 gcc/testsuite/gcc.dg/analyzer/data-model-5.c  |   13 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-5b.c |   12 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-5c.c |   13 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-5d.c |   61 +-
 gcc/testsuite/gcc.dg/analyzer/data-model-6.c  |   14 -
 gcc/testsuite/gcc.dg/analyzer/data-model-8.c  |    3 +-
 gcc/testsuite/gcc.dg/analyzer/describe-1.c    |   11 +
 gcc/testsuite/gcc.dg/analyzer/dot-output.c    |    3 +-
 gcc/testsuite/gcc.dg/analyzer/explode-1.c     |    2 +-
 gcc/testsuite/gcc.dg/analyzer/explode-2.c     |   16 +-
 gcc/testsuite/gcc.dg/analyzer/feasibility-1.c |   62 +
 gcc/testsuite/gcc.dg/analyzer/first-field-1.c |   24 +
 gcc/testsuite/gcc.dg/analyzer/first-field-2.c |   33 +
 gcc/testsuite/gcc.dg/analyzer/init.c          |  136 +
 gcc/testsuite/gcc.dg/analyzer/leak-2.c        |    9 +
 .../loop-0-up-to-n-by-1-with-iter-obj.c       |   73 +
 .../gcc.dg/analyzer/loop-0-up-to-n-by-1.c     |   31 +
 gcc/testsuite/gcc.dg/analyzer/loop-2a.c       |   10 +-
 gcc/testsuite/gcc.dg/analyzer/loop-3.c        |    7 +-
 gcc/testsuite/gcc.dg/analyzer/loop-4.c        |   13 +-
 .../gcc.dg/analyzer/loop-n-down-to-1-by-1.c   |   35 +
 .../analyzer/loop-start-down-to-end-by-1.c    |   35 +
 .../analyzer/loop-start-down-to-end-by-step.c |   30 +
 .../analyzer/loop-start-to-end-by-step.c      |   36 +
 .../analyzer/loop-start-up-to-end-by-1.c      |   34 +
 gcc/testsuite/gcc.dg/analyzer/loop.c          |    9 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-1.c      |   26 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-4.c      |    4 +-
 .../gcc.dg/analyzer/malloc-in-loop.c          |   19 +
 .../analyzer/malloc-ipa-8-double-free.c       |   82 +-
 .../gcc.dg/analyzer/malloc-ipa-8-unchecked.c  |    6 +-
 .../gcc.dg/analyzer/malloc-paths-9.c          |   59 +-
 .../gcc.dg/analyzer/malloc-vs-local-1a.c      |   22 +-
 .../gcc.dg/analyzer/malloc-vs-local-2.c       |   10 +-
 .../gcc.dg/analyzer/malloc-vs-local-3.c       |    5 +-
 gcc/testsuite/gcc.dg/analyzer/memset-1.c      |  100 +
 gcc/testsuite/gcc.dg/analyzer/paths-3.c       |    4 +-
 gcc/testsuite/gcc.dg/analyzer/paths-4.c       |   10 +-
 gcc/testsuite/gcc.dg/analyzer/paths-6.c       |    4 +-
 gcc/testsuite/gcc.dg/analyzer/paths-7.c       |    6 +-
 .../analyzer/pr93032-mztools-simplified.c     |   22 +
 .../gcc.dg/analyzer/pr93032-mztools.c         |  331 +
 gcc/testsuite/gcc.dg/analyzer/pr93382.c       |    6 +-
 gcc/testsuite/gcc.dg/analyzer/pr93938.c       |   13 +
 gcc/testsuite/gcc.dg/analyzer/pr94099.c       |    3 +-
 gcc/testsuite/gcc.dg/analyzer/pr94399.c       |   13 +
 gcc/testsuite/gcc.dg/analyzer/pr94447.c       |    2 +-
 gcc/testsuite/gcc.dg/analyzer/pr94458.c       |   23 +
 gcc/testsuite/gcc.dg/analyzer/pr94640.c       |   17 +
 gcc/testsuite/gcc.dg/analyzer/pr94688.c       |    6 +
 gcc/testsuite/gcc.dg/analyzer/pr94689.c       |    8 +
 gcc/testsuite/gcc.dg/analyzer/pr94839.c       |   20 +
 gcc/testsuite/gcc.dg/analyzer/pr95026.c       |   17 +
 gcc/testsuite/gcc.dg/analyzer/pr95240.c       |   27 +
 gcc/testsuite/gcc.dg/analyzer/refcounting-1.c |   31 +
 gcc/testsuite/gcc.dg/analyzer/single-field.c  |   37 +
 gcc/testsuite/gcc.dg/analyzer/stale-frame-1.c |   15 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-1.c    |   43 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-2.c    |   32 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-3.c    |   12 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-4.c    |   20 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-5.c    |   29 +
 gcc/testsuite/gcc.dg/analyzer/symbolic-6.c    |   24 +
 gcc/testsuite/gcc.dg/analyzer/taint-1.c       |   22 +-
 .../gcc.dg/analyzer/torture/loop-inc-ptr-1.c  |   15 +
 .../gcc.dg/analyzer/torture/loop-inc-ptr-2.c  |   17 +
 .../gcc.dg/analyzer/torture/loop-inc-ptr-3.c  |   18 +
 gcc/testsuite/gcc.dg/analyzer/unknown-fns-2.c |  238 +
 gcc/testsuite/gcc.dg/analyzer/unknown-fns-3.c |   67 +
 gcc/testsuite/gcc.dg/analyzer/unknown-fns-4.c |   15 +
 gcc/testsuite/gcc.dg/analyzer/unknown-fns.c   |    8 +-
 .../gcc.dg/analyzer/use-after-free.c          |   12 +
 gcc/testsuite/gcc.dg/analyzer/vla-1.c         |   13 +
 gcc/testsuite/gcc.dg/analyzer/zlib-4.c        |   10 +-
 .../gfortran.dg/analyzer/pr93993.f90          |    2 +-
 gcc/tristate.h                                |    2 +
 142 files changed, 16356 insertions(+), 10411 deletions(-)
 create mode 100644 cover-letter.txt
 create mode 100644 gcc/analyzer/region-model-impl-calls.cc
 create mode 100644 gcc/analyzer/region-model-manager.cc
 create mode 100644 gcc/analyzer/region-model-reachability.cc
 create mode 100644 gcc/analyzer/region-model-reachability.h
 create mode 100644 gcc/analyzer/region.cc
 create mode 100644 gcc/analyzer/store.cc
 create mode 100644 gcc/analyzer/store.h
 create mode 100644 gcc/analyzer/svalue.cc
 create mode 100644 gcc/testsuite/g++.dg/analyzer/pr94011.C
 create mode 100644 gcc/testsuite/g++.dg/analyzer/pr94503.C
 create mode 100644 gcc/testsuite/g++.dg/analyzer/pr95042.C
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/CVE-2005-1689-dedupe-issue-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/abs-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/aliasing-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/aliasing-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/bzero-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/casts-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/casts-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/compound-assignment-4.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/compound-assignment-5.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/data-model-20.c
 delete mode 100644 gcc/testsuite/gcc.dg/analyzer/data-model-6.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/describe-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/feasibility-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/first-field-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/first-field-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/init.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/leak-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-0-up-to-n-by-1-with-iter-obj.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-0-up-to-n-by-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-n-down-to-1-by-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-start-down-to-end-by-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-start-down-to-end-by-step.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-start-to-end-by-step.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/loop-start-up-to-end-by-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/malloc-in-loop.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/memset-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr93032-mztools-simplified.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr93032-mztools.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr93938.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94399.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94458.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94640.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94688.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94689.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr94839.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr95026.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pr95240.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/refcounting-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/single-field.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/stale-frame-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-3.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-4.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-5.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/symbolic-6.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/torture/loop-inc-ptr-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/torture/loop-inc-ptr-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/torture/loop-inc-ptr-3.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/unknown-fns-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/unknown-fns-3.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/unknown-fns-4.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/use-after-free.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/vla-1.c

diff --git a/gcc/analyzer/analyzer-logging.cc b/gcc/analyzer/analyzer-logging.cc
index 91ee584b7d7..d2bbd05d323 100644
--- a/gcc/analyzer/analyzer-logging.cc
+++ b/gcc/analyzer/analyzer-logging.cc
@@ -30,6 +30,8 @@ along with GCC; see the file COPYING3.  If not see
 
 #if ENABLE_ANALYZER
 
+#pragma GCC diagnostic ignored "-Wformat-diag"
+
 namespace ana {
 
 /* Implementation of class logger.  */
diff --git a/gcc/analyzer/analyzer-selftests.cc b/gcc/analyzer/analyzer-selftests.cc
index 8e200a3844b..aa2fd30c481 100644
--- a/gcc/analyzer/analyzer-selftests.cc
+++ b/gcc/analyzer/analyzer-selftests.cc
@@ -58,6 +58,7 @@ run_analyzer_selftests ()
   analyzer_region_model_cc_tests ();
   analyzer_sm_file_cc_tests ();
   analyzer_sm_signal_cc_tests ();
+  analyzer_store_cc_tests ();
 #endif /* #if ENABLE_ANALYZER */
 }
 
diff --git a/gcc/analyzer/analyzer-selftests.h b/gcc/analyzer/analyzer-selftests.h
index 7924b8c8f01..af40d36e92b 100644
--- a/gcc/analyzer/analyzer-selftests.h
+++ b/gcc/analyzer/analyzer-selftests.h
@@ -41,6 +41,7 @@ extern void analyzer_program_state_cc_tests ();
 extern void analyzer_region_model_cc_tests ();
 extern void analyzer_sm_file_cc_tests ();
 extern void analyzer_sm_signal_cc_tests ();
+extern void analyzer_store_cc_tests ();
 
 } /* end of namespace ana::selftest.  */
 
diff --git a/gcc/analyzer/analyzer.cc b/gcc/analyzer/analyzer.cc
index 8bc3ce49f07..814f6248992 100644
--- a/gcc/analyzer/analyzer.cc
+++ b/gcc/analyzer/analyzer.cc
@@ -32,6 +32,36 @@ along with GCC; see the file COPYING3.  If not see
 
 #if ENABLE_ANALYZER
 
+namespace ana {
+
+/* Workaround for missing location information for some stmts,
+   which ultimately should be solved by fixing the frontends
+   to provide the locations (TODO).  */
+
+location_t
+get_stmt_location (const gimple *stmt, function *fun)
+{
+  if (get_pure_location (stmt->location) == UNKNOWN_LOCATION)
+    {
+      /* Workaround for missing location information for clobber
+	 stmts, which seem to lack location information in the C frontend
+	 at least.  Created by gimplify_bind_expr, which uses the
+	   BLOCK_SOURCE_END_LOCATION (BIND_EXPR_BLOCK (bind_expr))
+	 but this is never set up when the block is created in
+	 c_end_compound_stmt's pop_scope.
+	 TODO: fix this missing location information.
+
+	 For now, as a hackish workaround, use the location of the end of
+	 the function.  */
+      if (gimple_clobber_p (stmt) && fun)
+	return fun->function_end_locus;
+    }
+
+  return stmt->location;
+}
+
+} // namespace ana
+
 /* Helper function for checkers.  Is the CALL to the given function name,
    and with the given number of arguments?
 
diff --git a/gcc/analyzer/analyzer.h b/gcc/analyzer/analyzer.h
index a7401128517..d234fcf47e7 100644
--- a/gcc/analyzer/analyzer.h
+++ b/gcc/analyzer/analyzer.h
@@ -35,24 +35,45 @@ class superedge;
   class callgraph_superedge;
     class call_superedge;
     class return_superedge;
+
 class svalue;
   class region_svalue;
   class constant_svalue;
-  class poisoned_svalue;
   class unknown_svalue;
+  class poisoned_svalue;
   class setjmp_svalue;
+  class initial_svalue;
+  class unaryop_svalue;
+  class binop_svalue;
+  class sub_svalue;
+  class unmergeable_svalue;
+  class placeholder_svalue;
+  class widening_svalue;
+  class compound_svalue;
+  class conjured_svalue;
+typedef hash_set<const svalue *> svalue_set;
 class region;
-  class map_region;
-  class array_region;
+  class frame_region;
+  class function_region;
+  class label_region;
+  class decl_region;
   class symbolic_region;
+  class element_region;
+  class offset_region;
+  class cast_region;
+  class field_region;
+  class string_region;
+class region_model_manager;
+struct model_merger;
+class store_manager;
+class store;
 class region_model;
 class region_model_context;
   class impl_region_model_context;
+class call_details;
 class constraint_manager;
 class equiv_class;
-struct model_merger;
-struct svalue_id_merger_mapping;
-struct canonicalization;
+
 class pending_diagnostic;
 class state_change_event;
 class checker_path;
@@ -60,6 +81,7 @@ class extrinsic_state;
 class sm_state_map;
 class stmt_finder;
 class program_point;
+class function_point;
 class program_state;
 class exploded_graph;
 class exploded_node;
@@ -73,9 +95,95 @@ class state_purge_per_ssa_name;
 class state_change;
 class rewind_info_t;
 
+class engine;
+
 /* Forward decls of functions.  */
 
+extern void dump_tree (pretty_printer *pp, tree t);
 extern void dump_quoted_tree (pretty_printer *pp, tree t);
+extern void print_quoted_type (pretty_printer *pp, tree t);
+extern int readability_comparator (const void *p1, const void *p2);
+extern int tree_cmp (const void *p1, const void *p2);
+
+/* A tree, extended with stack frame information for locals, so that
+   we can distinguish between different values of locals within a potentially
+   recursive callstack.  */
+
+class path_var
+{
+public:
+  path_var (tree t, int stack_depth)
+  : m_tree (t), m_stack_depth (stack_depth)
+  {
+    // TODO: ignore stack depth for globals and constants
+  }
+
+  bool operator== (const path_var &other) const
+  {
+    return (m_tree == other.m_tree
+	    && m_stack_depth == other.m_stack_depth);
+  }
+
+  operator bool () const
+  {
+    return m_tree != NULL_TREE;
+  }
+
+  void dump (pretty_printer *pp) const;
+
+  tree m_tree;
+  int m_stack_depth; // or -1 for globals?
+};
+
+typedef offset_int bit_offset_t;
+typedef offset_int bit_size_t;
+typedef offset_int byte_size_t;
+
+/* The location of a region expressesd as an offset relative to a
+   base region.  */
+
+class region_offset
+{
+public:
+  static region_offset make_concrete (const region *base_region,
+				      bit_offset_t offset)
+  {
+    return region_offset (base_region, offset, false);
+  }
+  static region_offset make_symbolic (const region *base_region)
+  {
+    return region_offset (base_region, 0, true);
+  }
+
+  const region *get_base_region () const { return m_base_region; }
+
+  bool symbolic_p () const { return m_is_symbolic; }
+
+  bit_offset_t get_bit_offset () const
+  {
+    gcc_assert (!symbolic_p ());
+    return m_offset;
+  }
+
+  bool operator== (const region_offset &other)
+  {
+    return (m_base_region == other.m_base_region
+	    && m_offset == other.m_offset
+	    && m_is_symbolic == other.m_is_symbolic);
+  }
+
+private:
+  region_offset (const region *base_region, bit_offset_t offset,
+		 bool is_symbolic)
+  : m_base_region (base_region), m_offset (offset), m_is_symbolic (is_symbolic)
+  {}
+
+  const region *m_base_region;
+  bit_offset_t m_offset;
+  bool m_is_symbolic;
+};
+
+extern location_t get_stmt_location (const gimple *stmt, function *fun);
 
 } // namespace ana
 
@@ -124,4 +232,76 @@ struct pod_hash_traits : typed_noop_remove<Type>
   static inline bool is_empty (Type);
 };
 
+/* A hash traits class that uses member functions to implement
+   the various required ops.  */
+
+template <typename Type>
+struct member_function_hash_traits : public typed_noop_remove<Type>
+{
+  typedef Type value_type;
+  typedef Type compare_type;
+  static inline hashval_t hash (value_type v) { return v.hash (); }
+  static inline bool equal (const value_type &existing,
+			    const value_type &candidate)
+  {
+    return existing == candidate;
+  }
+  static inline void mark_deleted (Type &t) { t.mark_deleted (); }
+  static inline void mark_empty (Type &t) { t.mark_empty (); }
+  static inline bool is_deleted (Type t) { return t.is_deleted (); }
+  static inline bool is_empty (Type t) { return t.is_empty (); }
+};
+
+/* A map from T::key_t to T* for use in consolidating instances of T.
+   Owns all instances of T.
+   T::key_t should have operator== and be hashable.  */
+
+template <typename T>
+class consolidation_map
+{
+public:
+  typedef typename T::key_t key_t;
+  typedef T instance_t;
+  typedef hash_map<key_t, instance_t *> inner_map_t;
+  typedef typename inner_map_t::iterator iterator;
+
+  /* Delete all instances of T.  */
+
+  ~consolidation_map ()
+  {
+    for (typename inner_map_t::iterator iter = m_inner_map.begin ();
+	 iter != m_inner_map.end (); ++iter)
+      delete (*iter).second;
+  }
+
+  /* Get the instance of T for K if one exists, or NULL.  */
+
+  T *get (const key_t &k) const
+  {
+    if (instance_t **slot = const_cast<inner_map_t &> (m_inner_map).get (k))
+      return *slot;
+    return NULL;
+  }
+
+  /* Take ownership of INSTANCE.  */
+
+  void put (const key_t &k, T *instance)
+  {
+    m_inner_map.put (k, instance);
+  }
+
+  size_t elements () const { return m_inner_map.elements (); }
+
+  iterator begin () const { return m_inner_map.begin (); }
+  iterator end () const { return m_inner_map.end (); }
+
+private:
+  inner_map_t m_inner_map;
+};
+
+/* Disable -Wformat-diag; we want to be able to use pp_printf
+   for logging/dumping without complying with the rules for diagnostics.  */
+
+#pragma GCC diagnostic ignored "-Wformat-diag"
+
 #endif /* GCC_ANALYZER_ANALYZER_H */
diff --git a/gcc/analyzer/analyzer.opt b/gcc/analyzer/analyzer.opt
index 3133cdd4106..b0c797ff9a7 100644
--- a/gcc/analyzer/analyzer.opt
+++ b/gcc/analyzer/analyzer.opt
@@ -34,10 +34,18 @@ The maximum number of exploded nodes per program point within the analyzer, befo
 Common Joined UInteger Var(param_analyzer_max_recursion_depth) Init(2) Param
 The maximum number of times a callsite can appear in a call stack within the analyzer, before terminating analysis of a call that would recurse deeper.
 
+-param=analyzer-max-svalue-depth=
+Common Joined UInteger Var(param_analyzer_max_svalue_depth) Init(13) Param
+The maximum depth of a symbolic value, before approximating the value as unknown.
+
 -param=analyzer-min-snodes-for-call-summary=
 Common Joined UInteger Var(param_analyzer_min_snodes_for_call_summary) Init(10) Param
 The minimum number of supernodes within a function for the analyzer to consider summarizing its effects at call sites.
 
+-param=analyzer-max-enodes-for-full-dump=
+Common Joined UInteger Var(param_analyzer_max_enodes_for_full_dump) Init(200) Param
+The maximum depth of exploded nodes that should appear in a dot dump before switching to a less verbose format.
+
 Wanalyzer-double-fclose
 Common Var(warn_analyzer_double_fclose) Init(1) Warning
 Warn about code paths in which a stdio FILE can be closed more than once.
diff --git a/gcc/analyzer/call-string.cc b/gcc/analyzer/call-string.cc
index 288953ed37c..d3630316c4e 100644
--- a/gcc/analyzer/call-string.cc
+++ b/gcc/analyzer/call-string.cc
@@ -38,6 +38,8 @@ along with GCC; see the file COPYING3.  If not see
 
 #if ENABLE_ANALYZER
 
+#pragma GCC diagnostic ignored "-Wformat-diag"
+
 /* class call_string.  */
 
 /* call_string's copy ctor.  */
diff --git a/gcc/analyzer/checker-path.cc b/gcc/analyzer/checker-path.cc
index c07273460d5..5f2b8346485 100644
--- a/gcc/analyzer/checker-path.cc
+++ b/gcc/analyzer/checker-path.cc
@@ -46,6 +46,9 @@ along with GCC; see the file COPYING3.  If not see
 #include "tristate.h"
 #include "ordered-hash-map.h"
 #include "selftest.h"
+#include "analyzer/call-string.h"
+#include "analyzer/program-point.h"
+#include "analyzer/store.h"
 #include "analyzer/region-model.h"
 #include "analyzer/program-state.h"
 #include "analyzer/checker-path.h"
@@ -56,8 +59,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/constraint-manager.h"
 #include "analyzer/diagnostic-manager.h"
 #include "analyzer/checker-path.h"
-#include "analyzer/call-string.h"
-#include "analyzer/program-point.h"
 #include "analyzer/exploded-graph.h"
 
 #if ENABLE_ANALYZER
@@ -214,16 +215,16 @@ state_change_event::state_change_event (const supernode *node,
 					const gimple *stmt,
 					int stack_depth,
 					const state_machine &sm,
-					tree var,
+					const svalue *sval,
 					state_machine::state_t from,
 					state_machine::state_t to,
-					tree origin,
+					const svalue *origin,
 					const program_state &dst_state)
 : checker_event (EK_STATE_CHANGE,
 		 stmt->location, node->m_fun->decl,
 		 stack_depth),
   m_node (node), m_stmt (stmt), m_sm (sm),
-  m_var (var), m_from (from), m_to (to),
+  m_sval (sval), m_from (from), m_to (to),
   m_origin (origin),
   m_dst_state (dst_state)
 {
@@ -245,9 +246,12 @@ state_change_event::get_desc (bool can_colorize) const
 {
   if (m_pending_diagnostic)
     {
+      region_model *model = m_dst_state.m_region_model;
+      tree var = model->get_representative_tree (m_sval);
+      tree origin = model->get_representative_tree (m_origin);
       label_text custom_desc
 	= m_pending_diagnostic->describe_state_change
-	    (evdesc::state_change (can_colorize, m_var, m_origin,
+	    (evdesc::state_change (can_colorize, var, origin,
 				   m_from, m_to, m_emission_id, *this));
       if (custom_desc.m_buffer)
 	{
@@ -260,16 +264,16 @@ state_change_event::get_desc (bool can_colorize) const
 		  (can_colorize,
 		   "%s (state of %qE: %qs -> %qs, origin: %qE)",
 		   custom_desc.m_buffer,
-		   m_var,
+		   var,
 		   m_sm.get_state_name (m_from),
 		   m_sm.get_state_name (m_to),
-		   m_origin);
+		   origin);
 	      else
 		result = make_label_text
 		  (can_colorize,
-		   "%s (state of %qE: %qs -> %qs, origin: NULL)",
+		   "%s (state of %qE: %qs -> %qs, NULL origin)",
 		   custom_desc.m_buffer,
-		   m_var,
+		   var,
 		   m_sm.get_state_name (m_from),
 		   m_sm.get_state_name (m_to));
 	      custom_desc.maybe_free ();
@@ -281,27 +285,31 @@ state_change_event::get_desc (bool can_colorize) const
     }
 
   /* Fallback description.  */
-  if (m_var)
+  if (m_sval)
     {
+      label_text sval_desc = m_sval->get_desc ();
       if (m_origin)
-	return make_label_text
-	  (can_colorize,
-	   "state of %qE: %qs -> %qs (origin: %qE)",
-	   m_var,
-	   m_sm.get_state_name (m_from),
-	   m_sm.get_state_name (m_to),
-	   m_origin);
+	{
+	  label_text origin_desc = m_origin->get_desc ();
+	  return make_label_text
+	    (can_colorize,
+	     "state of %qs: %qs -> %qs (origin: %qs)",
+	     sval_desc.m_buffer,
+	     m_sm.get_state_name (m_from),
+	     m_sm.get_state_name (m_to),
+	     origin_desc.m_buffer);
+	}
       else
 	return make_label_text
 	  (can_colorize,
-	   "state of %qE: %qs -> %qs (origin: NULL)",
-	   m_var,
+	   "state of %qs: %qs -> %qs (NULL origin)",
+	   sval_desc.m_buffer,
 	   m_sm.get_state_name (m_from),
 	   m_sm.get_state_name (m_to));
     }
   else
     {
-      gcc_assert (m_origin == NULL_TREE);
+      gcc_assert (m_origin == NULL);
       return make_label_text
 	(can_colorize,
 	 "global state: %qs -> %qs",
@@ -954,7 +962,7 @@ checker_path::add_final_event (const state_machine *sm,
 			       tree var, state_machine::state_t state)
 {
   checker_event *end_of_path
-    = new warning_event (stmt->location,
+    = new warning_event (get_stmt_location (stmt, enode->get_function ()),
 			 enode->get_function ()->decl,
 			 enode->get_stack_depth (),
 			 sm, var, state);
diff --git a/gcc/analyzer/checker-path.h b/gcc/analyzer/checker-path.h
index 2eead25f058..7b86d48e983 100644
--- a/gcc/analyzer/checker-path.h
+++ b/gcc/analyzer/checker-path.h
@@ -193,26 +193,26 @@ public:
   state_change_event (const supernode *node, const gimple *stmt,
 		      int stack_depth,
 		      const state_machine &sm,
-		      tree var,
+		      const svalue *sval,
 		      state_machine::state_t from,
 		      state_machine::state_t to,
-		      tree origin,
+		      const svalue *origin,
 		      const program_state &dst_state);
 
   label_text get_desc (bool can_colorize) const FINAL OVERRIDE;
 
-  region_id get_lvalue (tree expr, region_model_context *ctxt) const
+  function *get_dest_function () const
   {
-    return m_dst_state.m_region_model->get_lvalue (expr, ctxt);
+    return m_dst_state.get_current_function ();
   }
 
   const supernode *m_node;
   const gimple *m_stmt;
   const state_machine &m_sm;
-  tree m_var;
+  const svalue *m_sval;
   state_machine::state_t m_from;
   state_machine::state_t m_to;
-  tree m_origin;
+  const svalue *m_origin;
   program_state m_dst_state;
 };
 
